#ifndef HELPER_FUNCTIONS_H
#define HELPER_FUNCTIONS_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

enum EnumPrintableChars : uint8_t { enumPrintableStart = 0, enumPrintableHexa = 0, enumPrintableJob, enumPrintableJoblist, enumPrintableAll, enumPrintableEnd };

//------------------------------STRING NUMERIC CONVERSION ---------------------
bool MaxPossibleValueInNnumberOfBytes(uint32_t* _maxPossible32int, uint8_t _allocatedByteNumber, uint8_t _byteNumber, char* _callingFunction, int _lineNo);
bool ConvertFloatToUint32(float _floatValue, uint32_t* _uint32value, char* _callingFunction, int _lineNo);
bool TransferByteArrayToUint32(uint32_t* _uint32value, uint8_t byteArray[], uint8_t bitsUsed, uint8_t arraySize, bool isNegative, char* _callingFunction, int _lineNo);
bool TransferUint32ToByteArray(uint32_t _uint32value, uint8_t byteArray[], uint8_t bitsUsed, uint8_t arraySize, bool isNegative, char* _callingFunction, int _lineNo);


#endif // HELPER_FUNCTIONS_H
