#ifndef JOB_H
#define JOB_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include <Arduino.h>
#include "Globals.h"

//***************************************** CLASS JOB ***************************************

enum class EJobVars : uint8_t {
	start = 0,
	status = 0,
	jobType,
	repeatInterval,
	day,
	weekday,
	scheduleType,
	hour,
	fifteenMin,
	repeatType,
	repeatNumber,
	end
}; // enum class EJobVars

#define USE_JOB_CLASS
#ifdef USE_JOB_CLASS
#define SIZE_JOB_jobStatus 1
#define SIZE_JOB_jobType 3
#define SIZE_JOB_repeatInterval 4
#define SIZE_JOB_day 5
#define SIZE_JOB_weekday 3
#define SIZE_JOB_scheduleType 3
#define SIZE_JOB_hour 5
#define SIZE_JOB_fifteenMin 2
#define SIZE_JOB_repeatType 1
#define SIZE_JOB_repeatNumber 4
#endif // USE_JOB_CLASS

struct JobData {
	boolean status : SIZE_JOB_jobStatus;
	uint8_t jobType : SIZE_JOB_jobType;
	uint8_t repeatInterval : SIZE_JOB_repeatInterval;
	uint8_t day : SIZE_JOB_day;
	uint8_t weekday : SIZE_JOB_weekday;
	uint8_t scheduleType : SIZE_JOB_scheduleType;
	uint8_t hour : SIZE_JOB_hour;
	uint8_t fifteenMin : SIZE_JOB_fifteenMin;
	boolean repeatType : SIZE_JOB_repeatType;
	uint8_t repeatNumber : SIZE_JOB_repeatNumber;
}; // JobData


class Job : public BitfieldStorage {
public:
	Job(uint8_t* _valuesArray, uint8_t _varCount);

	// Variable specific Set/Get functions on weekday
	//uint8_t GetWeekday() {
	//	return jobData.weekday;
	//}
	//void SetWeekday(uint8_t _weekday) {
	//	jobData.weekday = _weekday;
	//}

	void PrintValues();

private:
	//JobData jobData; // JobData
	//uint8_t varCount{0};
	//static const VarCharacteristics varCharacteristics[];
	static VarCharacteristics varCharacteristics[];
}; // class Job


#endif // JOB_H
