/* ATest.cpp
   called by Aardvark to test stuff
*/

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

// Scenario
// Ten events get defined in a MyEvents class which inherits from the EventStorage class.
// The scenario starts by defining an event class and instantiating it.
// The MyEvents class constructor initializes the events to 0 (i.e. not triggered) - events
// are printed by myEvents.PrintVariables(). 
// A couple of events are set and events are printed. The events are reset via Reset()
// and events are printed one third time.
//

#include "Globals.h"

//********************************************************
MyEvents::MyEvents(uint8_t _registerSize, uint8_t _eventCount, char* _eventLabels[]) 
	// 10 events defined
	: EventStorage(_registerSize, _eventCount, _eventLabels) {
	Reset();
}

char* myEventLabels[]{
  "send", "receive", "SMS", "5V", "8V", "tempLow", "tempHigh", "weightBody",
  "weightSuper", "dummy0"
};

void ATest() {

	MyEvents myEvents = MyEvents( /*events/byte*/ 7, /*event count*/ (uint8_t)EEvents::end, myEventLabels);
	//eventStorage.PrintVariables();

	uint8_t volts5{ 0 }, volts8{ 0 }, weightSuper{ 0 };
	Serial.println(F("************************"));
	Serial.println(F("Events after creating myEvents - all events set to 0."));
	myEvents.PrintVariables();
	myEvents.Set((uint8_t)EEvents::Volts5, 1);
	myEvents.Set((uint8_t)EEvents::Volts8, 1);
	myEvents.Set((uint8_t)EEvents::weightSuper, 1);
	Serial.println(F("************************"));
	Serial.println(F("Events Volts5, Volts8,  set to 1."));
	myEvents.PrintVariables();
	Serial.println(F("************************"));
	Serial.println(F("All events set back to zero."));
	myEvents.Reset();
	myEvents.PrintVariables();
} // ATest()

// END ATest.cpp
