#ifndef ATEST_H
#define ATEST_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

// Used in Flower class - an amateur's approach at classifying flowers,
// not at all scientific. The list could get a lot bigger
enum class EDefines : uint8_t { start = 0, none = 0, family, size, color, scent, odorStrength, plantType, end};
enum class EFamily : uint8_t { start = 0, none = 0, 
    Rose, Sunflower, Hydrangea, Lavender, Peony, Daisy,
    Orchid, Tulip, Lily, Lilac, Chrysanthemum, Dahlia, Daffodil,
    Iris, Periwinkle, Azalea, Carnation, Violet, end };
enum class ESize : uint8_t { start = 0, none = 0, small, medium, large, end };
enum class EColor : uint8_t { start = 0, none = 0, blue, green, lavender, orange, pink, 
    purple, red, white, yellow, tan, end };
enum class EScent : uint8_t { start = 0, none = 0, fragrant, woody, minty, sweet, chemical,
    popcorn, lemon, fruity, pungent, decayed, end };
enum class EOdorStrength : uint8_t { start = 0, none = 0, weak, medium, strong, end };
enum class EPlantType : uint8_t { start = 0, none = 0, stem, bush, thicket, end };

extern char* definesName[];
extern char* familyName[];
extern char* sizeName[];
extern char* nameColor[];
extern char* nameScent[];
extern char* nameOdorStrength[];
extern char* namePlantType[];

// Not used - for illustrative purposes
enum class EPetalCount : uint8_t { start = 0, none = 0, singleP, doubleP, multipleP, end };
enum class EPetalShape : uint8_t { start = 0, none = 0, rounded, pointed, oblong, spatulate, lanceolate , end };
enum class EType : uint8_t { start = 0, none = 0, herbaceous, woody, end };
enum class EGrouping : uint8_t { start = 0, none = 0, alone, cluster, spike, umbrella, branched, end };
enum class ESeason : uint8_t { start = 0, none = 0, sprin, summer, fall, winter, warmth, end };
enum class EGrowth : uint8_t { start = 0, none = 0, annual, perennial, biennnial, end };
enum class EClass : uint8_t { start = 0, none = 0, dicot, monocot, end };

class Flower : public LinkedListItem {// pure virtual class
public:
    Flower(char* _name, EFamily _family, EPlantType _plantType, ESize _size, EColor _color, EScent _scent, EOdorStrength _odorStrength);
    void PrintItem(); 
private: 
    char* name;
    EFamily family{ EFamily::none };
    EPlantType plantType{ EPlantType::none };
    ESize size{ ESize::none };
    EColor color{ EColor::none };
    EScent scent{ EScent::none };
    EOdorStrength odorStrength{ EOdorStrength::none };
}; // Flower

class Garden : public LinkedListManage {
public:
    Garden(char* _name);
    ~Garden() {};
    //void PrintList();
private:
    char* name;
};

void ATest();


#endif // ATEST_H
