/* Test.cpp
   called by Aardvark to test stuff
*/

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

// Scenario - This project illustrates using two frameworks: 
//		Function Creation Framework
//		Project Documentation Framework
// 
// Function Creation Framework - This framework, although independently cited in my 
// Defensive C++ Arduino Programming book, is really part of the Project Documentation Framework.
// 
// Project Documentation Framework - The fundamental concept of this framework is to profit
// from the need to document work as one progresses in the development stage by formalizing how
// one comments code. 
// 
// Projects contain files, classes, structures, functions (methods), and functions which
// call functions. All of these should be documented, to respond to many needs:
//	-	Documenting code helps the developer refine his thinking. 
//  -	It is a	 reminder as why code is coded the way it is, useful to the code's creator when
//		he/she comes back to it months later, and to others who might be using the code.
// -	If sufficiently structured, comments can be extracted and fused into an overall project
//		documentation.
// The Project Documentation Framework comprises two parts:
//	-	Templates for distinct project components (file, class, etc.)
//	-	A Perl program which extracts comments from the source code.
// The framework also contains a template to extract function calls; i.e., extract who calls whom.
// The scenario documents three functions: Aardvark, Test, CharAt, and a few function calls.
//

void ATest() {
	// FUNCTION DOC START Test()
	// DESCRIPTION
	// The Project Files Framework is based on setup calling Aardvark 
	// which is where things start happening. As mentioned on numerous 
	// occasions, the Arduino loop function is not used. As the 
	// application's development progresses, you may want to try stuf.
	// Instead of doing it in Aardvark(), do it in Test() and have Aardvark
	// not get polluted with irrelevant code..
	// ERROR CHECKING
	// Error checks total : 0
	// None
	// PARAMETERS
	// Parameters total : 0
	// None
	// RETURNS
	// Returns void
	// FUNCTION DOC END Test()
	// PROGRAM FLOW START calling function: Test ()
	
	PRINT_FUNCTION_ENTER_NL;

	Serial.println(F("*************** Test() function - Start doing something. ***************"));
	// PROGRAM FLOW CALLS DoSomething()
	//DoSomething();

	Serial.println(F("*************** Test() function - Finished doing stuff. ***************"));


	PRINT_FUNCTION_EXIT_NL;
	return;
	// PROGRAM FLOW END calling function: Test ()
} // Test

// END FILE Test.cpp
