/* Aardvark.cpp
   called by setup defined in Sketch.cpp or ProjectFiles.ino
*/

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Aardvark.h"

// APPLICATION NAME Project Documentation Framework

void Aardvark() {
	// FUNCTION DOC START Aardvark ()
	// DESCRIPTION
	// Traditional Arduino IDE programming has a setup () and a loop () function.
	// loop () not being used, the program starts and ends in setup (), nothing being called by loop ().
	// The code which would be normally put in setup () is put in Aardvark (),
	// setup () is limited to calling Aardvark ().
	// This ensures interoperability between the Arduino IDE and Atmel Studio.
	// In AtmelStudio, sketch.cpp contains setup () which calls Aardvark ().
	// In the Arduino IDE, the .ino file contains setup () which calls Aardvark ().
	// This arrangement enables to switch development between AtmelStudio and the Arduino IDE
	// by simply commenting/uncommenting one #define located in the Global.h file.
	// ERROR CHECKING
	// Error checks total : 0
	// None
	// PARAMETERS
	// Parameters total : 0
	// None
	// RETURNS
	// Returns void
	// FUNCTION DOC END
	// PROGRAM FLOW START calling function: Aardvark()

	Serial.begin(115200);

	PRINT_FUNCTION_ENTER_NL;

	// PROGRAM FLOW CALLS Test()
	ATest();

	PRINT_FUNCTION_EXIT_NL;
	return;
	// PROGRAM FLOW END calling function: Ardvark()
} // Aardvark

// END file Aardvark.cpp
