# typical data to parse with perl

############# FILE CONTENTS

#  PROGRAM DOC START AardvarkBG()
#  FUNCTION DESCRIPTION AardvarkBG()
#  Main function, replaces setup which does nothing except call Aardvark().
#  Does Initializations - StationDataArray
#  ERROR CHECKING
#  Error checks total : 1
#  Could not turn SIM card on
#  Parameters : 0
#  Parameters total : 0
#  None
#  Returns : void
#  PROGRAM DOC END

#Documentation types to handle - CPP files
# PROGRAM_FILE, PROGRAM_FUNCTION
#Documentation types to handle - H files
# PROGRAM_CLASS

# These should be at the very beginning because functoins might need them.
use strict;
#use warning;
use diagnostics;

use feature 'say'; # like print but adds newline
use feature "switch"; # like switch statement

use IO::File;

#Global variables
my $printDocMode = 0; my $printLine = 0; my $offsetLine = 0;
my $functionName = "";
my $className = "";
my $docLineCountMAX = 50;
my $docLineCount = 0;
my $numberCalledFunctions = 0;
my $numberFunctionsDefined = 0;
my $calledFunctionsList = "Calling function Called function\n";
my $exportedContent = "";
my $applicationName = "";

# Define functions - start with BEGIN and END
BEGIN { 
$\ = "\n";
$" = ":";
#print (<>);
print "\n\nDoing BEGIN";

#open(TESTFILE, "regexTests.cpp");
} # BEGIN

END {
print "Finished work in files ";
print "total number of functions defined = ", $numberFunctionsDefined;
}

# Define user function
# sub PrintLineRemainder {
	# local($num);
	# $num = $0[1];
	# # prints remainder of line starting with $num
	# for ( $i = $num; $i < 100; $i++) {
		# print $ind;
	# } # for
	# print " ";
# } # PrintLineRemainder

# sub HandlePROGRAM_FILE {
	# # No need to capture filename since global, provided as argument
	# # Perl does not recognize \ s in regexes, use [\t ] instead
	# # TEST line
	# my $TestLineSTART = "PROGRAM FILE START";
	# my $regexStart = "/^[\t ]*\/\/[\t ]*PROGRAM[\t ]+FILE[\t ]+START/";
	# my $regexEnd = "/^[\t ]*\/\/[\t ]*PROGRAM[\t ]+FILE[\t ]+END/";

# }# HandlePROGRAM_FILE
# sub HandlePROGRAM_FUNCTION {
	# my $TestLineSTART = "PROGRAM FILE START Function1";
	# my $regexStart = "/^[\t ]*\/\/[\t ]*PROGRAM[\t ]+FUNCTION[\t ]+START[\t ]*((.+?))/";
	# my $regexEnd = "/^[\t ]*\/\/[\t ]*PROGRAM[\t ]+FUNCTION[\t ]+END/";

# }# HandlePROGRAM_FUNCTION
# sub HandlePROGRAM_CLASS {
	# my $TestLineSTART = "PROGRAM FILE START Class1";
	# my $regexStart = "/^[\t ]*\/\/[\t ]*PROGRAM[\t ]+CLASS[\t ]+START[\t ]*((.+?))/";
	# my $regexEnd = "/^[\t ]*\/\/[\t ]*PROGRAM[\t ]+CLASS[\t ]+END/";

# }# HandlePROGRAM_CLASS


sub HandleHfile {
	my $lineCount = 0;
	my $file = $_[0] . ".h";
	my $fileHandle = IO::File->new($file, "r");
	my $OKtoPrintLine = 0;
	if (defined $fileHandle) {
		print 'HandleCPPfile: Processing CPP file = ', $file;
	}
	while (my $line = <$fileHandle>) {
		# while (my $line = <$fileHandle> && $lineCount < 24) {
		chomp $line;
		print $line;

		# match // PROGRAM FUNCTION START
		if ( $line =~ /^[\t ]*\/\/[\t ]*PROGRAM[\t ]+FUNCTION[\t ]+START/) {
			$OKtoPrintLine = 1;
			$line = $line . " file: $file";
			# my @tokens = split /[\t ]+/, $line;
			# my $tokensCount = scalar(@tokens);
			# say "tokensCount = $tokensCount";
		} # if
			
		# match // PROGRAM FUNCTION END
		if ( $line =~ /^[\t ]*\/\/[\t ]*PROGRAM[\t ]+FUNCTION[\t ]+END/) {
			$OKtoPrintLine = 0;
			$line = $line . " file: $file";
			say ("printing line #: $lineCount - $line");
			# my @tokens = split /[\t ]+/, $line;
			# my $tokensCount = scalar(@tokens);
			# say "tokensCount = $tokensCount";
		} # if
		$lineCount++;
	} # while

	close $fileHandle;

} # HandleHfile

sub HandleCPPfile {
	my $lineCount = 0;
	my $file = $_[0] . ".cpp";
	my $fileHandle = IO::File->new($file, "r");
	my $OKtoPrintLine = 0;
	my $callingFunction = "";
	my $calledFunction = "";
	my $callingFunctionActive = 0;

	if (defined $fileHandle) {
		print 'HandleCPPfile: Processing CPP file = ', $file;
	}
	while (my $line = <$fileHandle>) {
	    chomp($line); # removes trailing CR
		# The following neeeds debugging - strane IO:File message
	    #print($line);
		# if ( $OKtoPrintLine == 1 ) {
			# # Remove // comment at beginning of line
			# $line =~ /^\s*\/\/\s*(.*)/;
			# $line = $1;
			# $exportedContent = $exportedContent . $line . "\n";
		# } else {
			#$exportedContent = $exportedContent . $line . "\n";
		#}
		$exportedContent = $exportedContent . $line . "\n";
		
		# match // APPLICATION NAME project name
		if ( $line =~ /^\s*\/\/\s*APPLICATION\s+NAME\s+(.*)/ ) {
			$applicationName = $1;
		} # if
		
		# match // APPLICATION SCENARIO START
		if ( $line =~ /^\s*\/\/\s*APPLICATION\s+SCENARIO\s+START/ ) {
			$callingFunction = $1;
			$OKtoPrintLine = 1;
			$exportedContent = $exportedContent . $line . "\n";
		} # if
		
		# match // APPLICATION SCENARIO END
		if ( $line =~ /^\s*\/\/\s*+APPLICATION\s+SCENARIO\s+END/) {
			$callingFunction = $1;
			$OKtoPrintLine = 0;
			$exportedContent = $exportedContent . $line . "\n";
		} # if
		
		# match // FUNCTION DOC START Aardvark ()
		if ( $line =~ /^\s*\/\/\s*FUNCTION\s+DOC\s+START\s+(.*)/ ) {
			$callingFunction = $1;
			$OKtoPrintLine = 1;
			$exportedContent = $exportedContent . $line . "\n";
		} # if
		
		# match // FUNCTION DOC END Aardvark ()
		if ( $line =~ /^\s*\/\/\s*+FUNCTION\s+DOC\s+END/) {
			$callingFunction = $1;
			$OKtoPrintLine = 0;
			$exportedContent = $exportedContent . $line . "\n";
		} # if

		# match // PROGRAM FLOW START
		if ( $line =~ /^\s*\/\/\s*PROGRAM\s+FLOW\s+START\s+calling\s+function:\s+(\w+)/ ) {
			$callingFunction = $1;
		} # if
		
		# match // PROGRAM FLOW CALLS
		if ( $line =~ /^\s*\/\/\s*PROGRAM\s+FLOW\s+CALLS\s+(\w+)/ ) {
			$calledFunction = $1;
			$calledFunctionsList = $calledFunctionsList . 
				$callingFunction . "\t" . $calledFunction . "\n"
		} # if
		
		# match // PROGRAM FLOW END
		if ( $line =~ /^\s*\/\/\s*PROGRAM\s+FLOW\s+END\s+calling\s+function:\s+(\w+)/ ) {
			if ( ($1 cmp $callingFunction) != 0) {
				print "** Error, cannot have different calling function when ending proram flow";
				print "\tSTART calling function: " . $calledFunction;
				print "\tEND calling function: " . $1;
				print "** Probably missing something or mispelled function name";
			}
		} # if
		
		$lineCount++;
	} # while

	close $fileHandle;
	print "Number of lines processed = ", $lineCount;

} #HandleCPPfile

############################################  PROGRAM STARTS HERE ##########################################

my $noFiles = scalar(@ARGV);
$noFiles -= 2;
print "Number of files in command line: ", $noFiles;
my @files = @ARGV[2..$noFiles+2-1];
print "Number of files in files array: ", scalar(@files);
print "Fileset:", "Input folder: ", $ARGV[0], "Output folder: ", $ARGV[1];

for ( my $i = 0; $i < $noFiles; $i++ ) {
	HandleCPPfile($files[$i]);
}

my $file = "ProjectDocumentationFramework.txt";
my $fileHandle = IO::File->new($file, "w");
print $fileHandle $applicationName . "\n" . $exportedContent . $calledFunctionsList;
print "######################### APPLICATION NAME ####################";
print $applicationName;
print "######################### EXPORTED CONTENT ####################";
print $exportedContent;
print "######################### CALLING FUNCTION LIST ####################";
print $calledFunctionsList;
print "######################### END PROCESSING ####################";

exit;

# # Now do the work by cycling through files
# for (my $i = 0; $i< $noFiles; $i++) {
	# # cycle through files
	# my $file = $files[$i];
	# # do CPP file - HandleCPPfile
	# HandleCPPfile($file);
	# # do H file - HandleHfile
	# #HandleHfile($file);
# } # for

# print "Exiting PROGRAM";
# exit;

#******************************** OLD AWK STUFF *************************************************

############# FILEGROUP - START/END 
# awk doc keywords: grouping, parenthese, capture
# Fileset START
#AWK LINE /^[ \t]*(\/\/[ \t]*PROGRAM)[ \t]+FILESET[ \t]+START[ \t]+(.+?)[ \t]+((.+?))/ {


#AWK LINE }
# Filegroup START

# Fileset END
# /PROGRAM\s+FILESET\s+END\s+\b(.+?)\b[ \t]*((.+?))/ {
# print "Fileset: ", $1, " - END";
#}
# Fileset END

############# FILE DESCRIPTION
# print file documentation start
#AWK LINE /PROGRAM\s+FILE\s+DESCRIPTION\s+START/ {
# # $printDocMode = 1;
# # $printLine = 0;
# # $functionName = $6;
# # $docLineCount = 0;
# # $numberFunctionsDefined = 0;
#print "File", FILENAME;
#AWK LINE }
# print file documentation start

# print file documentation end
#AWK LINE /PROGRAM\s+FILE\s+DESCRIPTION\s+END/ {
# # $printDocMode = 0;
# # $printLine = 0;
# #$1 = "";
#AWK LINE }
# print file documentation end

############# CLASS DECLARATION
# Class declaration start
#AWK LINE /PROGRAM\s+CLASS\s+DECLARATION\s+START/ {
# # $className = $6;
PrintLineRemainder(6);
#AWK LINE }
# Class declaration start

# Class declaration end
#AWK LINE /PROGRAM\s+CLASS\s+DECLARATION\s+END/ {
# # print "Number of methods defined in ", $className, " = ", $numberFunctionsDefined;
#AWK LINE }
# Class declaration end

############# CLASS DESCRIPTION
# Class description start
#AWK LINE /PROGRAM\s+CLASS\s+DESCRIPTION\s+START/ {
# # $printDocMode = 1;
# # $printLine = 0;
# # $className = $6;
# # $docLineCount = 0;
# # $numberFunctionsDefined = 0;
#print "class", FILENAME;
#AWK LINE }
# Class description start

# Class description end
#AWK LINE /PROGRAM\s+CLASS\s+DESCRIPTION\s+END/ {
# # $printDocMode = 0;
# # $printLine = 0;
#$1 = "";
#AWK LINE }
# Class description end

############# METHOD DECLARATION
# Method declaration
#AWK LINE /PROGRAM\s+METHOD\s+DECLARATION/ {
#$5 = $className . "::" . $5;
PrintLineRemainder(5);
# # $numberFunctionsDefined++;
#AWK LINE }
# Method declaration


############# FUNCTION DECLARATION
# Function declaration
#AWK LINE /PROGRAM\s+FUNCTION\s+DECLARATION/ {
PrintLineRemainder(5);
#AWK LINE }
# Function declaration

############# CODE FILE

#handle Parameters
#AWK LINE /PARAMETERS/{
# # $printLine = 0;
# # $offsetLine = 0;
#print"Handle PARAMETERS";
#AWK LINE }
#handle Parameters

#handle Returns
#AWK LINE /RETURNS/{
# # $printLine = 0;
# # $offsetLine = 0;
#print"Handle RETURNS";
#AWK LINE }
#handle Returns

# print program start
#AWK LINE /PROGRAM\s+DOC\s+START/ {
# # $printDocMode = 1;
# # $printLine = 0;
# # $functionName = $5;
# # $docLineCount = 0;
# # $numberCalledFunctions = 0;
# # $numberFunctionsDefined++;
#print "*********************************************************************************";
# # print "FUNCTION", $functionName;
#AWK LINE }
# print program start

# print documentation end
#AWK LINE /PROGRAM\s+DOC\s+END/ {
# # $printDocMode = 0;
# # $printLine = 0;
#$1 = "";
# # print " Called functions:";
#AWK LINE }
# print documentation end

# print documentation end
#AWK LINE /PROGRAM\s+FLOW\s+END/ {
# # $printLine = 0;
# # $offsetLine = 0;
#$1 = "";
# # print "Finished with", $functionName , "number of called functions = ", $numberCalledFunctions;
# # print "*********************************************************************************\n";
#AWK LINE }
# print documentation end

# print called function
#AWK LINE /PROGRAM\s+FLOW\s+CALLS/ {
# # $printLine = 0;
# # $calledFunction = $5;
# # if ( $5 ne "None" ) {$numberCalledFunctions ++;}
# # #$1 = "";
# # print "\t", $calledFunction;
#AWK LINE }
# print called function

#AWK LINE /Parameters total :/{
# # $offsetLine = 0;
#AWK LINE }

#AWK LINE /Returns/{
# # $offsetLine = 0;
#AWK LINE }

#prints entire line if condition is met
# { 
# if($offsetLine == 1) $1 = "\t";
# else $1 = "";
# if ( $printDocMode == 1 && $printLine == 1) {
	# print $0;
	# $docLineCount++;
# }
# $printLine = 1; #by default print line
# $offsetLine = 1; # by default offset line
# } 
#prints entire line if condition is met

