// Begin HelperFunctions.cpp

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

int16_t CharAt(char* _searchString, char _searchChar, uint16_t _startPosition = 0) {
	// FUNCTION DOC START CharAt ()
	// DESCRIPTION
	// ERROR CHECKING
	// Error checks total : 0
	// None
	// PARAMETERS
	// Parameters total : 3
	// char* _searchString
	// char _searchChar
	// uint16_t _startPosition
	// RETURNS
	// Returns int16_t - position of _searchChar in _searchString - zero based
	// Return -1 if string not found
	// FUNCTION DOC END CharAt ()
	// PROGRAM FLOW START calling function: CharAt ()

	int16_t indexAt{ -1 };
	int16_t _searchStringLength = strlen(_searchString);

	for (int16_t i = _startPosition; i < _searchStringLength; i++) {
		if (_searchString[i] == _searchChar) {
			indexAt = i;
			break;
		}
	}

	return indexAt;
	// PROGRAM FLOW END calling function: CharAt ()
} // CharAt()

// End HelperFunctions.cpp
