#ifndef MACROS_H
#define MACROS_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

// ----------------------------------- PROGRAMMING AID ------------------------------------
#define MILESTONE_DISPLAY(PARAM_text) \
  Serial.println(F("<MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM>")); \
  Serial.println(F(PARAM_text)); \
  Serial.println(F("<MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM>"));
  
#define PRINT_FUNCTION_ENTER \
Serial.print(F("FUNCTION START: "));Serial.print(__FUNCTION__); Serial.print(F(" : ")); Serial.print(__LINE__);

#define PRINT_FUNCTION_ENTER_NL \
  PRINT_FUNCTION_ENTER Serial.println();

#define PRINT_FUNCTION_EXIT \
Serial.print(F("FUNCTION EXIT: "));Serial.print(__FUNCTION__); Serial.print(F(" : ")); Serial.print(__LINE__);

#define PRINT_FUNCTION_EXIT_NL \
  PRINT_FUNCTION_EXIT Serial.println();

#define PRINT_VALUE_EQUAL(_VALUE) \
  Serial.print(F("Value of ")); Serial.print(#_VALUE); \
  Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_VALUE_EQUAL_TAB(_VALUE) \
  Serial.print(F("\t value of ")); Serial.print(#_VALUE); \
  Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_TEXT_VALUE_EQUAL(TEXT, _VALUE) \
  Serial.print(F(TEXT)); \
  Serial.print(F(", value of ")); Serial.print(#_VALUE); \
  Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_VALUE_EQUAL_HEADER(HEADER1, HEADER2, _VALUE) \
  Serial.println(HEADER1);Serial.println(HEADER2); \
  Serial.print(F("\t value of ")); Serial.print(#_VALUE); \
  Serial.print(F(" = ")); Serial.println(_VALUE);

#define PLACE_IN_PROGRAM \
  Serial.print(F("Function : ")); \
  Serial.print(__FUNCTION__); \
  Serial.print(F(" Line no = ")); \
  Serial.println(__LINE__);


#endif // MACROS_H
