#ifndef GLOBALS_H
#define GLOBALS_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include <Arduino.h>
#include "Macros.h"

//#define ARDUINO_IDE
#define ATMEL_STUDIO

#define ARDUINO_328
//#define ARDUINO_MEGA

// These fall within the context of the Print-based Debugging Framework
// Controls what gets reported
//#define ABSOLUTELY_NO_PRINTS
#define GENERAL_REPORTING // GENERAL_REPORTING_ON or MEMORY_MANAGEMENT, not both
#define ERROR_REPORTNG
//#define MEMORY_MANAGEMENT 
#define MINIMAL_REPORTING
#define TIME_REPORTING 

#if defined(GENERAL_REPORTING) && defined(MEMORY_MANAGEMENT)
#error "Define ENERAL_REPORTING or MEMORY_MANAGEMENT but not both at the same time""
#endif // defined(GENERAL_REPORTING) && defined(MEMORY_MANAGEMENT)

//#define ABSOLUTELY_NO_PRINTS // Activate to turn off all prints
#ifdef ABSOLUTELY_NO_PRINTS
#undef GENERAL_REPORTING
#undef ERROR_REPORTING
#undef MINIMAL_REPORTING
#undef MEMORY_MANAGEMENT
#undef TIME_REPORTING
#endif // ABSOLUTELY_NO_PRINTS


//================================= FILE BASED REPORTING ==========================
#ifdef GENERAL_REPORTING
#define _DEBUG_SKETCH 
#define _DEBUG_AARDVARK
#define _DEBUG_TEST
#define _DEBUG_GLOBALS
#define _DEBUG_HELPER_FUNCTIONS
#define _DEBUG_FUNCTIONS
#define _DEBUG_FUNCTIONS_SKL
#define _DEBUG_BASIC_CLASS
#endif // GENERAL_REPORTING_ON
//====================================================================
#if (defined (GENERAL_REPORTING) && defined (MEMORY_MANAGEMENT))
#error "Need to define GENERAL_REPORTING_ON or MEMORY_MANAGEMENT or none"
#endif

//================== VERIFY ENVIRONMENTAL DEFINES ===========================
#if (defined (ARDUINO_MEGA) && defined (ARDUINO_328)) || (!defined (ARDUINO_MEGA) && !defined (ARDUINO_328))
#error "Need to define ARDUINO_MEGA or ARDUINO_328, one only not both"
#endif

#if (defined (ARDUINO_IDE) && defined (ATMEL_STUDIO)) || (!defined (ARDUINO_IDE) && !defined (ATMEL_STUDIO))
#error "Need to define ARDUINO_IDE or ATMEL_STUDIO_IDE, one only not both"
#endif

//================================= INCLUDES ==========================

#include "HelperFunctions.h"
#include "Functions.h"
#include "FunctionsSKL.h"
#include "BasicClass.h"
#include "ATest.h"
#include "Aardvark.h"

#endif // GLOBALS_H
