#ifndef GLOBALS_H
#define GLOBALS_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include <Arduino.h>
#include "Macros.h"

//#define ARDUINO_IDE
#define ATMEL_STUDIO
//#define PLATFORM_IO

// define programming environment
#if \
 (!defined(ATMEL_STUDIO) && !defined(ARDUINO_IDE) && !defined(PLATFORM_IO)) || \
 (defined(ATMEL_STUDIO) && defined(ARDUINO_IDE) && defined(PLATFORM_IO)) || \
 (!defined(ATMEL_STUDIO) && defined(ARDUINO_IDE) && defined(PLATFORM_IO)) || \
 (defined(ATMEL_STUDIO) && defined(ARDUINO_IDE) && !defined(PLATFORM_IO)) || \
 (!defined(ATMEL_STUDIO) && defined(ARDUINO_IDE) && defined(PLATFORM_IO)) 
#error (F("You must define one programming environment, only one"))
#endif // Define programming environment

//#define ARDUINO_MEGA
#define ARDUINO_328

#if \
	((!defined(ARDUINO_MEGA) && !defined(ARDUINO_328)) || \
	(defined(ARDUINO_MEGA) && defined(ARDUINO_328))) 
#error (F("You must define one r, only one"))
#endif // Define programming environment

// These defines can be uncommented bottom up, otherwise error.
#define USE_CLASS_NAMES
#define USE_MEM_ALLOC_TRACKING
#define USE_ERROR_RPT

#if \
	(defined(USE_CLASS_NAMES) && !defined(USE_MEM_ALLOC_TRACKING))
#error (F("Class names framework only when using mem tracking."))
#endif // Use class names framework

//Define classIndex to match CandF names use
#ifdef USE_CLASS_NAMES
#define CLASS_INDEX_PARAMETER EClass _classIndex
#define CLASS_INDEX_PARAMETER_TRANSFER _classIndex
#define CLASS_INDEX_DECLARATION EClass classIndex  
#define CLASS_INDEX_USE(_arg) EClass::_arg
#else
#define CLASS_INDEX_PARAMETER uint16_t _classIndex
#define CLASS_INDEX_PARAMETER_TRANSFER 0
#define CLASS_INDEX_DECLARATION uint16_t classIndex  
#define CLASS_INDEX_USE(_arg) (uint16_t) 0
#endif

//--------------------------- INCLUDES

#include "TestPaths.h"
#include "ATest.h"
#include "Aardvark.h"

#endif // GLOBALS_H
