// Begin TestPaths.cpp

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

char* eDataModeLabels[]{ "none", "data", "maintenance", "other" };
char* eStructPathsLabels[]{
	"registered", "notRegisteredRegisterTemp", "registeredLimitReached",
	"dataModeDoNothing", "maintenanceModuleHasRealName", "maintenanceModuleHasTempName"
};
char* eStructResultsLabels[]{
	"doNothing", "registerSetRealName",	"maxNumberReached",
	"setTempNameAndRegister", "setRealNameAndRegister", "errorBadMode"
};


StructPath structPaths[]{
	 StructPath("Cynthia", EDataMode::data, true, 10, EStructExpectedResults::doNothing), // 1
	 StructPath("Registered6", EDataMode::maintenance, true, 10, EStructExpectedResults::registeredSetRealName), // 2
	 StructPath("Cynthia", EDataMode::none, false, 16, EStructExpectedResults::maxNumberReached), // 3
	 StructPath("Cynthia", EDataMode::other, false, 10, EStructExpectedResults::errorBadMode), // 4
	 StructPath("Cynthia", EDataMode::data, false, 10, EStructExpectedResults::setTempNameAndRegister), // 5
	 StructPath("Cynthia", EDataMode::maintenance, false, 10, EStructExpectedResults::setRealNameAndRegister) // 6
};

// End TestPaths.cpp