#ifndef TEST_PATHS_H
#define TEST_PATHS_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

enum class EDataMode : uint8_t { start = 0, none = 0, data, maintenance, other, end };
extern char* eDataModeLabels[];

enum class EStructPaths : uint8_t {
	start = 0,
	registered = 0, // 1
	notRegisteredRegisterTemp, // 3
	registeredLimitReached, // 2
	dataModeDoNothing, // 4
	maintenanceModuleHasRealName, // 5
	maintenanceModuleHasTempName, // 6
	end
};
extern char* eStructPathsLabels[];

enum class EStructExpectedResults : uint8_t {
	start = 0,
	doNothing = 0,
	registeredSetRealName,
	maxNumberReached,
	setTempNameAndRegister,
	setRealNameAndRegister,
	errorBadMode,
	end
};
extern char* eStructResultsLabels[];
struct StructPath {
	StructPath(char* _name,
		EDataMode _eDataMode, bool _isRegistered, 
		uint8_t _modulesInYard, EStructExpectedResults _eStructExpectedResults)
		: name(_name), eDataMode(_eDataMode), isRegistered(_isRegistered),
		modulesInYard(_modulesInYard), eStructExpectedResults(_eStructExpectedResults){}
	char* name;
	EDataMode eDataMode{ EDataMode::data };
	bool isRegistered{ true };
	uint8_t modulesInYard{ 16 };
	EStructExpectedResults eStructExpectedResults{ EStructExpectedResults::doNothing};
};
extern StructPath structPaths[];


#endif // TEST_PATHS_H
