#ifndef MACROS_H
#define MACROS_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

//***************************  FUNCTION ENTER/EXIT ***********************
#define PRINT_FUNCTION_ENTER \
Serial.print(F("START: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.print(__LINE__);

#define PRINT_FUNCTION_ENTER_NL \
Serial.print(F("START: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.println(__LINE__);

#define PRINT_FUNCTION_EXIT \
Serial.print(F("END: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.print(__LINE__);

#define PRINT_FUNCTION_EXIT_NL \
Serial.print(F("END: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.println(__LINE__);

#define PRINT_FILE_FUNCTION_ENTER_LINE_CALLED_BY_NL \
Serial.print(F("START: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.print(__LINE__);  \
Serial.print(F(" from "));Serial.print(_callingFunction);\
Serial.print(F(":"));Serial.println(_lineNo);

#define PRINT_FILE_FUNCTION_EXIT_LINE_CALLED_BY_NL \
Serial.print(F("END: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.print(__LINE__); \
Serial.print(F(" from:"));Serial.print(_callingFunction);\
Serial.print(F(":"));Serial.println(_lineNo);

//***************************  VALUE EQUAL ***********************
#define PRINT_VALUE_EQUAL(_VALUE) \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.print(_VALUE); Serial.print(" ");

#define PRINT_VALUE_EQUAL_BIN(_VALUE) \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.print(_VALUE, BIN); Serial.print(" ");

#define PRINT_VALUE_EQUAL_BIN_NL(_VALUE) \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE, BIN); 

#define PRINT_VALUE_EQUAL_NL(_VALUE) \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_VALUE_EQUAL_TAB_BIN_NL(_VALUE) \
Serial.print(F("\t")); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE, BIN); 

#define PRINT_VALUE_EQUAL_TAB_NL(_VALUE) \
Serial.print(F("\t")); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_VALUE_EQUAL_DESC(_DESC, _VALUE) \
Serial.print(F(_DESC)); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.print(_VALUE); Serial.print(" ");

#define PRINT_VALUE_EQUAL_DESC_NL(_DESC, _VALUE) \
Serial.print(F(_DESC)); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE); 

#define PRINT_VALUE_EQUAL_TAB_NL(_DESC, _VALUE) \
Serial.print(F("\t")); \
Serial.print(F(_DESC)); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_VALUE_EQUAL_TAB(_VALUE) \
Serial.print(F("\t")); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.print(_VALUE); Serial.print(" ");

#define PRINT_VALUE_EQUAL_TAB_NL(_VALUE) \
Serial.print(F("\t")); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_TEXT_VALUE_EQUAL(TEXT, _VALUE) \
Serial.print(F(TEXT)); \
Serial.print(F(", ")); Serial.print(F(#_VALUE)); Serial.print(F(" ")); Serial.println(_VALUE);

#define PRINT_MEMORY_CONSTANTS(_description) \
{ \
  Serial.print(F("&__data_start ")); Serial.println((uint16_t)&__data_start); \
  Serial.print(F("&__data_end ")); Serial.println((uint16_t)&__data_end); \
  Serial.print(F("&__bss_start ")); Serial.println((uint16_t)&__bss_start); \
  Serial.print(F("&__bss_end ")); Serial.println((uint16_t)&__bss_end); \
  Serial.print(F("&__heap_start ")); Serial.print((uint16_t)&__heap_start); \
  Serial.print(F(" points to ")); Serial.println((uint16_t)__heap_start); \
  Serial.print(F("&__heap_end ")); Serial.print((uint16_t)&__heap_end); \
  Serial.print(F(" points to ")); Serial.println((uint16_t)__heap_end); \
  Serial.print(F("__brkval ")); Serial.println((long)__brkval); \
  Serial.print(F("__ctors_start ")); Serial.println((long)&__ctors_start); \
  Serial.print(F("__ctors_end ")); Serial.println((long)&__ctors_end); \
}

#endif // MACROS_H
