#ifndef PERSONNEL_H
#define PERSONNEL_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol (France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

enum class EDept : uint8_t {
	stat = 0,
	unassigned = 0, electrical, research, dataProcessing, administration, production,
	end
}; // enum EDept

extern char* deptNames[];

class Employee : public LinkedListItem {
public:
	Employee(char* _name, EDept _dpt, uint16_t _itemID);
	~Employee() {};
	void PrintItem();
private:
	EDept dpt{ EDept::unassigned };
}; // Employee

// Initialize employee ID, starts with 1. Gets incremented each time 
// an employee is added, never gets decremented. Ir is not the number
// of employees in the company
//
class Company : public LinkedListManage {
public:
	Company(char* _name);
	void AddEmployee(Employee* _employee);
	void DeleteEmployee(Employee* _employee) {};
private:
}; // Department

#endif // PERSONNEL_H
