#ifndef CLASS_NAMES_H
#define CLASS_NAMES_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol (France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h""

//--------------------------------  CLASS NAME ----------------------------------------------------

#ifdef USE_CLASS_NAMES

// This class handles transforming class name enums into char* strings
// It does not handle functions
// It uses enum class EClass and global structCandFNames

class ClassNames {
public:
	//ClassNames(EClass _classIndex) : classIndex(_classIndex) {};
	ClassNames() {};
	~ClassNames() {};
	virtual char* GetClassName(EClass _classIndex);
	char* GetFunctionName(EClass _classIndex, uint8_t _functionIndex);
	uint16_t GetNumberOfClasses(); // includes index 0 --> "Undefined"
	uint8_t GetNumberOfFunctions(EClass _classIndex); // includes index 0 --> "Undefined"
	bool CheckClassIndex(EClass _classIndex);
	bool CheckFunctionIndex(EClass _classIndex, uint8_t _functionIndex);
	void PrintClassList();
	void PrintFunctionList(EClass _classIndex);
private:
	//EClass classIndex;
	//uint8_t functionIndex;
}; // class ClassName

#endif // USE_CLASS_NAMES


#endif // CLASS_NAMES_H
