// BEGIN EventMgt.cpp

#include "Globals.h"

#ifdef USE_ERROR_RPT

#define _DEBUG_EVENT_MGT_ON
#ifdef _DEBUG_EVENT_MGT_ON
// ----------------------------------------  ERROR RPT ----------------------------------------
//#define _DEBUG_ERROR_RPT_EVENT_LIST_APPEND_ITEM
#define _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_ITEM
#define _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_LIST

// ----------------------------------------  MEM ALLOC ----------------------------------------
//#define _DEBUG_MEM_ALLOC_EVENT_LIST_APPEND_ITEM
#define _DEBUG_MEM_ALLOC_EVENT_LIST_PRINT_ITEM
#define _DEBUG_MEM_ALLOC_EVENT_LIST_PRINT_LIST

// ----------------------------------------  MEMORY CONSTRUCTOR/DESTRUCTOR ----------------------------------------
//#define _DEBUG_CALCULATE_OBJECT_FU_SIZE
#define _DEBUG_HANDLE_MEMORY_CONSTRUCTOR
//#define _DEBUG_HANDLE_MEMORY_DESTRUCTOR
#define _DEBUG_HEAP_SPACE_DIAGNOSTICS
#endif // _DEBUG_MEM_MGT_ON


#ifdef _DEBUG_EVENT_MGT_ON


char* eErrorTypeLabels[] {
  "outOfBounds",
  "badAlloc",
  "Allocated",
  "Released"
};

#endif // _DEBUG_EVENT_MGT_ON

//ErrorRptEvent::classIndex = (uint16_t) EClass::ErrorRptEvent;

ErrorRptEventMgt* errorRptEventMgt = new ErrorRptEventMgt ();


ErrorRptEventMgt::ErrorRptEventMgt () {
  #ifdef USE_CLASSNAME
  classNameList = new CandFNames ();
  #endif // USE_CLASSNAME
  errorRptList = new ErrorRptList ();
  
} // ErrorRptEventMgt constructor

void ErrorRptEventMgt::Print () {
  errorRptList->PrintList ();
} // ErrorRptEventMgt

void ErrorRptEventMgt::Append (ErrorRptEvent* _errorRptEvent) {
  #ifdef _DEBUG_ERROR_RPT_EVENT_LIST_APPEND_ITEM
  PRINT_FUNCTION_ENTER_NL
  Serial.println (F ("Appending item to ERROR list"));
  #endif _DEBUG_ERROR_RPT_EVENT_LIST_APPEND_ITEM
  
  errorRptList->AppendItem (_errorRptEvent);
  
  #ifdef _DEBUG_ERROR_RPT_EVENT_LIST_APPEND_ITEM
  PRINT_FUNCTION_EXIT
  #endif _DEBUG_ERROR_RPT_EVENT_LIST_APPEND_ITEM
  return;
}; // ErrorRptEventMgt


void ErrorRptList::PrintList (){
  #ifdef _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_LIST
  PRINT_FUNCTION_ENTER_NL
  #endif // _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_LIST

  #ifdef PRINT_WHEN_ALL_ELSE_OFF
  Serial.println (F ("Errors detected:"));
  PrintItems ();
  #endif // PRINT_WHEN_ALL_ELSE_OFF

  #ifdef _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_LIST
  PRINT_FUNCTION_EXIT
  #endif // _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_LIST
  return;
} // PrintList ()

void ErrorRptEvent::PrintItem (bool _insertNewLine) {
  #ifdef _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_ITEM
  PRINT_FUNCTION_ENTER_NL
  #endif // _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_ITEM
  //uint8_t functionIndex = (uint8_t) EErrorRptEvent::PrintItem;
  uint8_t functionIndex = (uint8_t) 1;
  #ifdef PRINT_WHEN_ALL_ELSE_OFF
  #ifdef USE_CLASS_NAMES
  Serial.print (F ("  "));
  Serial.print (classAndFunctionNames->GetClassName (classIndex));
  Serial.print (F ("::"));
  Serial.print (classAndFunctionNames->GetFunctionName (classIndex, functionIndex));
  Serial.print (F (":"));
  #else
  Serial.print (F ("  classIndex/functionIndex "));
  Serial.print (classIndex);
  Serial.print (F ("/"));
  Serial.print (functionIndex);
  Serial.print (F (" lineNo "));
  #endif
  Serial.print (GetLineNo ());
  Serial.print (F (", status "));
  Serial.print (eErrorTypeLabels[ (uint8_t)status]);
  if ( _insertNewLine == true ) {
    Serial.println ();
  }
  #endif // PRINT_WHEN_ALL_ELSE_OFF
  
  #ifdef _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_ITEM
  PRINT_FUNCTION_EXIT
  #endif // _DEBUG_ERROR_RPT_EVENT_LIST_PRINT_ITEM
  return;
} // PrintItem ;

 
// ----------------------------------------  MEMORY CONSTR!UCTOR/DESTRUCTOR ----------------------------------------

#endif // USE_EVENT_MGT

// END EventMgt.cpp
