#ifndef ERROR_RPT_H
#define ERROR_RPT_H

#include "Globals.h"
#ifdef USE_ERROR_RPT

//------------------------------------------------ ERROR EVENTS CREATION FOLLOW UP ------------------------------------------------------------

// As objects get created and deleted, details on object creation/deletion
// are stored in global array ErrorRptList::linkedList. This array's size is initalized to a fix value
// Each array item contains info plus the class name's address. The class name's is contained in a link list
// of class names progressively built up as items are created.


//--------------------------------  ERROR EVENT F/U ----------------------------------------------------
enum class EErrorType : uint8_t {
  start = 0,
  outOfBounds = 0, // retires contact from data base
  badAlloc,
  allocated,
  released,
  end
}; // enum EErrorType

extern char* eErrorTypeLabels[];

class ErrorRptEvent : public LinkedListItem {
  public:
  ErrorRptEvent ( EErrorType _status ) : LinkedListItem (),
  status (_status)
  { } // ErrorRptEvent constructor

  void PrintItem (bool _insertNewline);
  int16_t classIndex;
  private:
  //static uint16_t classIndex{(uint16_t) EClass::ErrorRptEvent};
  //char** functionLabels;
  EErrorType status;
}; // class ErrorRptEvent

class ErrorRptList : public LinkedList {
  public:
  ErrorRptList () : LinkedList () {}
  void PrintList ();
  private:
}; // class ObjectCreationFollowUpList

#ifdef USE_CLASS_NAMES
class ErrorRptEventMgt : public CandFNames {
#else
class ErrorRptEventMgt {
#endif // USE_CLASS_NAMES
  public:
  ErrorRptEventMgt ();

  void Append (ErrorRptEvent* _errorRptEvent);
  void Print ();
  ErrorRptList* GetErrorRptList (){ return errorRptList;};

  private:
  #ifdef USE_CLASSNAME
  CandFNames* classNameList;
  #endif // USE_CLASSNAME
  ErrorRptList* errorRptList{0};
}; //  class ErrorRptEventMgt

#endif // USE_ERROR_RPT

#endif // ERROR_RPT_H
