#ifndef GLOBALS_H
#define GLOBALS_H

#include <Arduino.h>
#include "Macros.h"

//#define ARDUINO_IDE
#define ATMEL_STUDIO
//#define PLATFORM_IO

// define programming environment
#if \
 (!defined(ATMEL_STUDIO) && !defined(ARDUINO_IDE) && !defined(PLATFORM_IO)) || \
 (defined(ATMEL_STUDIO) && defined(ARDUINO_IDE) && defined(PLATFORM_IO)) || \
 (!defined(ATMEL_STUDIO) && defined(ARDUINO_IDE) && defined(PLATFORM_IO)) || \
 (defined(ATMEL_STUDIO) && defined(ARDUINO_IDE) && !defined(PLATFORM_IO)) || \
 (!defined(ATMEL_STUDIO) && defined(ARDUINO_IDE) && defined(PLATFORM_IO)) 
#error (F("You must define one programming environment, only one"))
#endif // Define programming environment

//#define ARDUINO_MEGA
#define ARDUINO_328

#if \
((!defined(ARDUINO_MEGA) && !defined(ARDUINO_328)) || \
(defined(ARDUINO_MEGA) && defined(ARDUINO_328))) 
#error (F("You must define one micropocessor, only one"))
#endif // Define programming environment

// These defines can be uncommented bottom up, otherwise error.
//#define USE_CLASS_FUNCTION_IDS
//#define USE_CLASS_NAMES
//#define USE_MEM_ALLOC_TRACKING


#if defined(USE_CLASS_NAMES) && !defined(USE_CLASS_FUNCTION_IDS)
#error "Using class names (USE_CLASS_NAMES) requires that USE_CLASS_FUNCTION_IDS be defined"
#endif

//--------------------------- MEMORY MANAGEMENT
#define AUTO_CHAR_ARRAY (PARAMname, PARAMsize) \
char PARAMname[PARAMsize + 1];

#define AUTO_CHAR_ARRAY_INIT (PARAMname, PARAMsize) \
for (int i = 0; i < (PARAMsize + 1); i++) { \
  PARAMname[i] = ' '; \
} \
PARAMname[PARAMsize] = 0;

#define AUTO_CHAR_ARRAY_NULL (PARAMname, PARAMsize) \
PARAMname[PARAMsize] = 0;

//--------------------------- INCLUDES

#include "ClassFunctionIDs.h"
#include "LinkedList.h"
#include "ClassNames.h"
#include "MemAlloc.h"
#include "Personnel.h"
#include "ATest.h"
#include "Aardvark.h"

#endif // GLOBALS_H
