// Begkin BeeHives.cpp

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

#ifdef _DEBUG_ENUM_STORAGE_ON
#define _DEBUG_ENUM_STORAGE_CONSTRUCTOR
#define _DEBUG_ENUM_STORAGE_DESTRUCTOR


#endif // _DEBUG_ENUM_STORAGE_ON

BeeYard::BeeYard(char* _name) {
	PRINT_FUNCTION_ENTER_NL;
	name = new char[strlen(_name) + 1];
	strcpy(name, _name);
	Serial.print("Bee yard '");
	Serial.print(name);
	Serial.print("' created - for max hive count = ");
	Serial.println(BEEYARD_NUMBER_HIVES);
	PRINT_FUNCTION_EXIT_NL;
} // Beeyard

void BeeYard::operator += (BeeHive* _beehive) {
	if (beehives[numberOfHives] == true) {
		beehives.array[numberOfHives] = _beehive;
		numberOfHives++;
	}
	else {
		Serial.print(F("Exceeded array limit - hive '"));
		Serial.print(_beehive->GetName());
		Serial.println(F("' not added."));
		ErrorRptItem* errorRptItem = new ErrorRptItem(EEventType::error, EErrorType::outOfBounds, 
			EClass::BeeYard, (uint8_t) EBeeYardFunctions::plusEqualOp, __LINE__);
		errorRptList.AddItem(errorRptItem);
		longjmp(envAbort, (uint8_t)EErrorType::outOfBounds);
	}
}

void BeeYard::PrintList() {
	PRINT_FUNCTION_ENTER_NL;
	Serial.print(F("Total number of beehives = "));
	Serial.println(numberOfHives);
	for (int i = 0; i < numberOfHives; i++) {
		Serial.print(F("beehive # "));
		Serial.print(i);
		Serial.print(F(": "));
		Serial.print(beehives.array[i]->GetName());
		Serial.println();
	} // for
	PRINT_FUNCTION_EXIT_NL;
} // PrintBeehiveNames

BeeHive::BeeHive(char* _name) {
	name = new char[strlen(_name) + 1];
	strcpy(name, _name);
} // Beehive

// End BeeHives.cpp
