#ifndef BEEHIVES_H
#define BEEHIVES_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

//------------------------------- STORAGE GROUP   ----------------------------------
// PROGRAM FILE DESCRIPTION START
// Two classes are defined (Beehive and Beeyard) to illustrate perator overloading
//   
// PROGRAM FILE DESCRIPTION END

//--------------------------------------------------- EEPROM METHODS ------------------------------------

#define BEEYARD_NUMBER_HIVES 4

class BeeHive {
public:
	BeeHive(char* _name);
	char* GetName() { return name; };
private:
	char* name;
}; // class BeeHive

class BeeYard {
public:
	BeeYard(char* _name);
	void operator += (BeeHive* _beehive);
	void PrintBeehiveNames();
	char* GetName() { return name; };
	uint8_t GetMaxNumberOfHives() { return maxNumberOfHives; }
	uint8_t GetNumberOfHives() { return numberOfHives; }
	void PrintList();
private:
	char* name;
	uint8_t numberOfHives{ 0 };
	uint8_t maxNumberOfHives{ BEEYARD_NUMBER_HIVES };
	SafeArray <BeeHive> beehives = SafeArray <BeeHive>(BEEYARD_NUMBER_HIVES);
}; // class Beeyard

#endif // BEEHIVES_H
