#ifndef CLASS_FUNCTION_IDS_H
#define CLASS_FUNCTION_IDS_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol(France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include "Globals.h"

#ifdef USE_CLASS_NAMES

struct StructCandFNames {
	char* classLabel;
	char** functionLabels;
};

extern StructCandFNames structCandFNames[];

enum class EClass : uint16_t {
	start = 0,
	none = 0,
	Global,
	LinkedListItem,
	LinkedListManage,
	BeeYard,
	BeeHive,
	end
}; // enum EClassEnums

enum class EGlobalFunctions : uint8_t {
	start = 0,
	HeapSpace = 0, FreeRAM, GetFreeRAM,
	PrintHeapSpace,
#ifdef USE_MEM_ALLOC_TRACKING
	new_operator,
#endif // USE_MEM_ALLOC_TRACKING
	end
}; // enum EGlobalFunctions

enum class EBeeHiveFunctions : uint8_t {
	start = 0,
	BeeHive = 0, PrintItem,
	end
}; // enum beeHiveFunctions

enum class EBeeYardFunctions : uint8_t {
	start = 0,
	BeeYard = 0, AddHive, RemoveHive, plusEqualOp,
	end
}; // enum beeYardFunctions

enum class ELinkedListItemFunctions : uint8_t {
	start = 0,
	LinkedListItem = 0, SetNext, SetPrevious, PrintItem,
	end
}; // enum ELinkedListItemFunctions

enum class ELinkedListManageFunctions : uint8_t {
	start = 0,
	LinkedListManage = 0, GetHead, GetTail, GetCount, AddItem, DeleteItem, InsertItem, SwapItems, FindItem, PrintList,
	end
}; // enum ELinkedListManageFunctions

extern char* globalFunctionsLabels[];
extern char* beeHiveFunctionsLabels[];
extern char* beeYardFunctionsLabels[];
extern char* linkedListItemFunctionsLabels[];
extern char* linkedListManageFunctionsLabels[];

#endif // USE_CLASS_NAMES

#endif // CLASS_FUNCTION_IDS_H
