#ifndef GLOBALS_H
#define GLOBALS_H

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// incorporate it inside of an executable or other machine language component
// without restriction for personal or commercial use.The Software may not be
// redistributed as source code or in any recognizable human readable form
// in any form whatsoever for any use whatsoever.
// 
// The Software is the property of Michle Delsol (France), copyright 2023 USA and
// international. For any questions concerning use of the software contact
// Michle Delsol at CPParduino@md-dsl.fr.
// 
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include <Arduino.h>

//#define ATMEGA_256_XMINI

#define ATMEL_STUDIO
//#define ARDUINO_IDE

#define ATMEGA_328P
#define ATMEGA_2560

//#define ERROR_REPORTING_ON
#define PROGRAM_ERROR_TEXT(_DESC) \
Serial.println((_DESC)); 

#define USE_LONG_JMP

// -------------------------- MACROS
#define PRINT_FUNCTION_ENTER_ASTERIX \
Serial.print(F("\n\nSTART: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.print(__LINE__); \
Serial.println(" ********************************");

#define PRINT_FUNCTION_ENTER_NL \
Serial.print(F("START: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.println(__LINE__);

#define PRINT_FUNCTION_ENTER_DESC_NL(_DESC) \
Serial.print(F("START: - ")); Serial.println(F(_DESC)); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.println(__LINE__);

#define PRINT_FUNCTION_EXIT_NL \
Serial.print(F("END: ")); \
Serial.print(__FUNCTION__); Serial.print(F(":"));Serial.println(__LINE__);

#define PRINT_VALUE_EQUAL(_VALUE) \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.print(_VALUE); Serial.print(" ");

#define PRINT_VALUE_EQUAL_BIN(_VALUE) \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.print(_VALUE, BIN); Serial.print(" ");

#define PRINT_VALUE_EQUAL_BIN_NL(_VALUE) \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE, BIN); 

#define PRINT_VALUE_EQUAL_NL(_VALUE) \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_VALUE_EQUAL_TAB_BIN_NL(_VALUE) \
Serial.print(F("\t")); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE, BIN); 

#define PRINT_VALUE_EQUAL_TAB_NL(_VALUE) \
Serial.print(F("\t")); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_VALUE_EQUAL_DESC(_DESC, _VALUE) \
Serial.print(F(_DESC)); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.print(_VALUE); Serial.print(" ");

#define PRINT_VALUE_EQUAL_DESC_NL(_DESC, _VALUE) \
Serial.print(F(_DESC)); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE); 

#define PRINT_VALUE_EQUAL_TAB_NL(_DESC, _VALUE) \
Serial.print(F("\t")); \
Serial.print(F(_DESC)); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE);

#define PRINT_VALUE_EQUAL_TAB(_VALUE) \
Serial.print(F("\t")); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.print(_VALUE); Serial.print(" ");

#define PRINT_VALUE_EQUAL_TAB_NL(_VALUE) \
Serial.print(F("\t")); \
Serial.print(F(#_VALUE)); Serial.print(F(" = ")); Serial.println(_VALUE);

#define AUTO_CHAR_ARRAY(PARAMname, PARAMsize) \
char PARAMname[PARAMsize + 1];

#define AUTO_CHAR_ARRAY_INIT(PARAMname, PARAMsize) \
for (int i = 0; i < (PARAMsize + 1); i++) { \
  PARAMname[i] = ' '; \
} \
PARAMname[PARAMsize] = 0;

#define AUTO_CHAR_ARRAY_NULL(PARAMname, PARAMsize) \
PARAMname[PARAMsize] = 0;

//--------------------------- INCLUDES

#include <setjmp.h>
#include "LinkedList.h"
#include "Primes.h"
#include "Aardvark.h"
#include "ATest.h"

#endif // GLOBALS_H
